# encoding: utf-8
class Gw::Admin::Webmail::SignsController < Gw::Controller::Admin::Base
  include Sys::Controller::Scaffold::Base
  layout "admin/gw/webmail"
  before_action :set_title
  before_action :set_before_url, only: [:new, :edit]
  
  def set_before_url
    before_path = Rails.application.routes.recognize_path(request.referrer)
    if ["index", "show"].include?(before_path[:action])
      session[:request_referrer] = request.referrer
    end
  end
  
  def pre_dispatch
    #return error_auth unless Core.user.has_auth?(:designer)
  end

  def index
    item = Gw::WebmailSign.readable
    item = item.where(user_id: Core.user.id)
               .paginate(page: params[:page], per_page: params[:limit])
               .order(name: :asc, id: :asc)
    @items = item.all
    _index @items
  end

  def show
    @item = Gw::WebmailSign.find(params[:id])
    return error_auth unless @item.readable?

    _show @item
  end

  def new
    @item = Gw::WebmailSign.new({
      :default_flag => 0
    })
  end

  def create
    @item = Gw::WebmailSign.new(item_params)
    @item.user_id = Core.user.id
    _create(@item)
  end

  def update
    @item = Gw::WebmailSign.find(params[:id])
    return error_auth unless @item.editable?
    @item.attributes = item_params
    @item.user_id = Core.user.id

    _update(@item)
  end

  def destroy
    @item = Gw::WebmailSign.find(params[:id])
    return error_auth unless @item.deletable?
    _destroy(@item)
  end
private
  #ヘッダのタイトルを設定するメソッド
  def set_title
    @title = I18n.t('rumi.mail.title.sign')
  end

  def item_params
    params.require(:item).permit(:name, :body, :default_flag)
  end
end
