# encoding: utf-8
class Gw::WebmailSign < ActiveRecord::Base
  include Sys::Model::Base
  include Sys::Model::Auth::Free

  validates_presence_of :user_id, :name

  after_save :uniq_default_flag, if: %Q(default_flag == 1)

  def self.readable
    self.where(user_id: Core.user.id)
  end

  def readable?
    user_id == Core.user.id
  end

  def editable?
    user_id == Core.user.id
  end

  def deletable?
    user_id == Core.user.id
  end

  def self.default_sign
    cond = {user_id: Core.user.id, default_flag: 1}
    self.where(cond).first
  end

  def self.user_signs
    item = readable
    item = item.where(user_id: Core.user.id)
               .order(name: :asc, id: :asc)
  end

protected
  def uniq_default_flag
    cond = Gw::WebmailSign.where(user_id: Core.user.id)
                          .where.not(id: id)
    cond.update_all(default_flag: 0) if cond.present?
    return true
  end
end
