Enisys::Application.routes.draw do

  root :to => 'gw/admin/webmail/mails#index', :mailbox => 'INBOX'

  ## Admin
  match '_admin'                 => 'gw/admin/webmail/mails#index', :mailbox => 'INBOX', :via => [:get, :post]
  match '_admin/login.:format'   => 'sys/admin/account#login', :via => [:get, :post]
  match '_admin/login'           => 'sys/admin/account#login', :via => [:get, :post]
  match '_admin/logout.:format'  => 'sys/admin/account#logout', :via => [:get, :post]
  match '_admin/logout'          => 'sys/admin/account#logout', :via => [:get, :post]
  match '_admin/smart_logout'    => 'sys/admin/account#smart_logout', :via => [:get, :post]
  match '_admin/account.:format' => 'sys/admin/account#info', :via => [:get, :post]
  match '_admin/account'         => 'sys/admin/account#info', :via => [:get, :post]
  match "_admin/sso"             => "sys/admin/account#sso", :via => [:get, :post]
  match '_admin/air_login'       => 'sys/admin/air#old_login', :via => [:get, :post]
  match '_admin/air_sso'         => 'sys/admin/air#login', :via => [:get, :post]
  match '_admin/cms'             => 'sys/admin/front#index', :via => [:get, :post]
  match '_admin/sys'             => 'sys/admin/front#index', :via => [:get, :post]

  ## Modules
  Dir::entries(Rails.root.join("config/modules")).each do |mod|
    next if mod =~ /^\.+$/
    file = Rails.root.join("config/modules/#{mod}/routes.rb")
    load(file) if FileTest.exist?(file)
  end

  ## Exception
  get '404.:format' => 'exception#index'
  get '*path'       => 'exception#index'
end
