# encoding: utf-8
module Enisys
  def self.version
    "1.0.0"
  end

  def self.default_config
    { "application" => {
        "sys.login_footer"                       => "",
        "sys.mobile_footer"                      => "",
        "sys.session_expiration"                 => 24,
        "sys.session_expiration_for_mobile"      => 1,
        "sys.force_site"                         => "",
        "webmail.mailbox_quota_alert_rate"       => 0.85,
        "webmail.attachment_file_max_size"       => 5,
#        "webmail.attachment_file_upload_method"  => "flash",
        "webmail.show_only_ldap_user"            => 1,
        "webmail.filter_condition_max_count"     => 100,
        "webmail.mail_address_history_max_count" => 100,
#        "webmail.synchronize_mobile_setting"     => 0,
        "webmail.show_gw_schedule_link"          => 1,
        "webmail.max_file_name_length"           => 200,
        "webmail.mail_menu"                      => I18n.t("rumi.mail.title.mail"),
        "webmail.mailbox_menu"                   => I18n.t("rumi.mail.title.folder"),
        "webmail.sys_address_menu"               => I18n.t("rumi.mail.title.sys_address"),
        "webmail.address_group_menu"             => I18n.t("rumi.mail.title.private_address"),
        "webmail.public_address_book_menu"       => I18n.t("rumi.mail.title.public_address"),
        "webmail.filter_menu"                    => I18n.t("rumi.mail.title.filter"),
        "webmail.template_menu"                  => I18n.t("rumi.mail.title.template"),
        "webmail.sign_menu"                      => I18n.t("rumi.mail.title.sign"),
        "webmail.memo_menu"                      => I18n.t("rumi.attributes.rumi_address_csv.import.memo"),
        "webmail.tool_menu"                      => I18n.t("rumi.mail.title.batch_delete"),
        "webmail.setting_menu"                   => I18n.t("rumi.config_settings.menu"),
        "webmail.doc_menu"                       => I18n.t("rumi.sys.menu.doc"),
        "gw.root_url" => nil,
        "version.major"                          => "2",
        "version.minor"                          => "0",
        "version.patch_level"                    => "0"
    }}
  end

  def self.config
    $enisys_config ||= {}
    Enisys::Config
  end

  def self.ie11_regexp
    /(Trident).*rv:(\d+)\.(\d*)/
  end

  def self.ie?(val)
    case val
    when String
      str = val
    when ActionDispatch::Request
      str = val.user_agent
    else
      return false
    end
    return true if (str.index(/MSIE/) || str.index(ie11_regexp))
    return false
  rescue
    return false
  end

  class Enisys::Config
    def self.application
      config = Enisys.default_config["application"]
      file   = Rails.root.join("config/application.yml")
      if ::File.exist?(file)
        yml = YAML.load_file(file)
        yml.each do |mod, values|
          values.each do |key, value|
            unless value.nil?
              if mod == "gw" && key == "root_url"
                begin
                  URI.parse(value)
                rescue
                  # 何もしない
                else
                  config["gw.root_url"] = value
                end
              else
                config["#{mod}.#{key}"] = value
              end
            end
          end if values
        end if yml
      end
      $enisys_config[:application] = config
    end

    def self.imap_settings
      $enisys_config[:imap_settings]
    end

    def self.imap_settings=(config)
      $enisys_config[:imap_settings] = config
    end

    def self.sso_settings
      $enisys_config[:sso_settings]
    end

    def self.sso_settings=(config)
      $enisys_config[:sso_settings] = config
    end
  end
end
