# encoding: utf-8
class Util::Database < ActiveRecord::Base
  include ShortcutMethod

  def self.lock_by_name(name, timeout = 30, &block)
    begin
      ActiveRecord::Base.connection.execute("SELECT GET_LOCK('#{name}', #{timeout});")
      yield
    rescue => e
      error_log(e)
    ensure
      begin
        ActiveRecord::Base.connection.execute("SELECT RELEASE_LOCK('#{name}');")
      rescue => e
        error_log(e)
      end
    end
  end

  def self.dump(data)
    Sys::Lib::Debugger::Dump.dump_log(data)
  end

  def self.error_log(message)
    Rails.logger.error "[ USER ERROR #{Time.now.strftime('%Y-%m-%d %H:%M:%S')} ]: #{message}"
  end

  def self.debug_log(data)
    Rails.logger.debug "[ DEBUG #{Time.now.strftime('%Y-%m-%d %H:%M:%S')} ]: #{data.pretty_inspect}"
  end
end